    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.io.BufferedReader

    java.lang.Object
       |
       +----java.io.Reader
               |
               +----java.io.BufferedReader

public class BufferedReader
extends Reader

Read text from a character-input stream, buffering characters so as to provide for the efficient reading of characters, arrays, and lines.

The buffer size may be specified, or the default size may be used. The default is large enough for most purposes.

In general, each read request made of a Reader causes a corresponding read request to be made of the underlying character or byte stream. It is therefore advisable to wrap a BufferedReader around any Reader whose read() operations may be costly, such as FileReaders and InputStreamReaders. For example,

     BufferedReader in
       = new BufferedReader(new FileReader("foo.in"));

will buffer the input from the specified file. Without buffering, each invocation of read() or readLine() could cause bytes to be read from the file, converted into characters, and then returned, which can be very inefficient.

Programs that use DataInputStreams for textual input can be localized by replacing each DataInputStream with an appropriate BufferedReader.

See Also:
  FileReader, InputStreamReader

##

BufferedReader(Reader)
  Create a buffering character-input stream that uses a default-sized input buffer.
BufferedReader(Reader, int)
  Create a buffering character-input stream that uses an input buffer of the specified size.

##

close()
  Close the stream.
mark(int)
  Mark the present position in the stream.
markSupported()
  Tell whether this stream supports the mark() operation, which it does.
read()
  Read a single character.
read(char[], int, int)
  Read characters into a portion of an array.
readLine()
  Read a line of text.
ready()
  Tell whether this stream is ready to be read.
reset()
  Reset the stream to the most recent mark.
skip(long)
  Skip characters.

##

BufferedReader

     public BufferedReader(Reader in,
                           int sz)

  Create a buffering character-input stream that uses an input buffer of the specified size.

  Parameters:
    in - A Reader
    sz - Input-buffer size
  Throws: IllegalArgumentException
    If sz is <= 0

BufferedReader

     public BufferedReader(Reader in)

  Create a buffering character-input stream that uses a default-sized input buffer.

  Parameters:
    in - A Reader

##

read

     public int read() throws IOException

  Read a single character.

  Throws: IOException
    If an I/O error occurs
  Overrides:
    read in class Reader

read

     public int read(char cbuf[],
                     int off,
                     int len) throws IOException

  Read characters into a portion of an array.

  Ordinarily this method takes characters from this stream's character buffer, filling it from the underlying stream as necessary. If, however, the buffer is empty, the mark is not valid, and the requested length is at least as large as the buffer, then this method will read characters directly from the underlying stream into the given array. Thus redundant `BufferedReader`s will not copy data unnecessarily.

  Parameters:
    cbuf - Destination buffer
    off - Offset at which to start storing characters
    len - Maximum number of characters to read
  Returns:
    The number of bytes read, or -1 if the end of the stream has been reached
  Throws: IOException
    If an I/O error occurs
  Overrides:
    read in class Reader

readLine

     public String readLine() throws IOException

  Read a line of text. A line is considered to be terminated by any one of a line feed ('\n'), a carriage return ('\r'), or a carriage return followed immediately by a linefeed.

  Returns:
    A String containing the contents of the line, not including any line-termination characters, or null if the end of the stream has been reached
  Throws: IOException
    If an I/O error occurs

skip

     public long skip(long n) throws IOException

  Skip characters.

  Parameters:
    n - The number of characters to skip
  Returns:
    The number of characters actually skipped
  Throws: IOException
    If an I/O error occurs
  Overrides:
    skip in class Reader

ready

     public boolean ready() throws IOException

  Tell whether this stream is ready to be read. A buffered character stream is ready if the buffer is not empty, or if the underlying character stream is ready.

  Throws: IOException
    If an I/O error occurs
  Overrides:
    ready in class Reader

markSupported

     public boolean markSupported()

  Tell whether this stream supports the mark() operation, which it does.

  Overrides:
    markSupported in class Reader

mark

     public void mark(int readAheadLimit) throws IOException

  Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point.

  Parameters:
    readAheadLimit - Limit on the number of characters that may be read while still preserving the mark. After reading this many characters, attempting to reset the stream may fail. A limit value larger than the size of the input buffer will cause a new buffer to be allocated whose size is no smaller than limit. Therefore large values should be used with care.
  Throws: IllegalArgumentException
    If readAheadLimit is < 0
  Throws: IOException
    If an I/O error occurs
  Overrides:
    mark in class Reader

reset

     public void reset() throws IOException

  Reset the stream to the most recent mark.

  Throws: IOException
    If the stream has never been marked, or if the mark has been invalidated
  Overrides:
    reset in class Reader

close

     public void close() throws IOException

  Close the stream.

  Throws: IOException
    If an I/O error occurs
  Overrides:
    close in class Reader

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.